﻿package
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.utils.setInterval;
	import flash.events.MouseEvent;
	import flash.utils.setTimeout;

	public class Genever extends Sprite
	{
		private var points:Array = new Array();
		private var numPoints:Number = 10;
		private var gravity:Number = 0.1;
		
		public function Genever()
		{
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
		}
		private function gravityChange (event:MouseEvent):void
		{
			gravity = (-0.3);
			setTimeout(returnNormal,500);
		}
		private function returnNormal ()
		{
			gravity = 0.1;
		}
		private function addedHandler(e:Event):void
		{
			addEventListener(Event.ENTER_FRAME,enterHandler);
			stage.addEventListener(MouseEvent.CLICK,gravityChange);
		}
		private function enterHandler(e:Event):void
		{
			addPoint();
			update();
			draw();
		}
		private function addPoint():void
		{
			var point:Object;
			if(points.length<numPoints){
				point = {};
				initPoint(point);
				points.push(point);
			}
			
		}
		private function initPoint(p:Object):void
		{
			p.x = stage.stageWidth/2;
			p.y = stage.stageHeight-22;
			p.vx = Math.random()*4-2;
			p.vy = Math.random()*-6-5;
			p.radius = Math.random()*5+1;
		}
		private function update():void
		{
			for(var i:Number = 0;i< points.length;i++){
				
				var dirx:Number=points[i].vx;
				var diry:Number=points[i].vy;
				
				if(points[i].x>stage.stageWidth-20  || points[i].x < 20){
					dirx *= -1;
				}
				if(points[i].y >= stage.stageHeight-20){
					diry *= -1;
					points[i].y = stage.stageHeight-20;
					
				}
				if(points[i].y < 20){
					if (gravity != 0.1) gravity *= -1;
					points[i].y = 20;
				}
				points[i].vy += gravity;
				
				points[i].x += dirx;
				points[i].y += diry;
			}
		}
		private function draw():void
		{
			this.graphics.clear();
			for(var i:Number = 0;i<points.length;i++){
				this.graphics.lineStyle(2,0xffffff);
				if (i<10){
					if (i>2) {
						this.graphics.moveTo(points[i-2].x,points[i-2].y);
						this.graphics.lineTo(points[i-1].x,points[i-1].y);
						this.graphics.beginFill(0xffffff,.5);
						this.graphics.drawCircle(points[i-1].x,points[i-1].y,10);
						this.graphics.endFill();
					}
				}
			}
		}
	}
}